include machine.e
--include safe.e
--include msgbox.e
include putsxy.e
--include database.e
--include tblib.e
--include csv.e
include mouse.e
include sort.e
include wildcard.e
include image.e
include misc.e
include get.e
include file.e
include graphics.e
------------------------------------------------------------------------
-- constants ---------
-- misc ---

-- Colors --
global constant black=0,
	 blue=1,
	 green=2,
	 cyan=3,
	 red=4,
	 magenta=5,
	 brown=6,
	 white=7,
	 gray=8,
	 b_blue=9,
	 b_green=10,
	 b_cyan=11,
	 b_red=12,
	 b_mag=13,
	 b_white=15,
	 yellow=14
------------------------------------------------------------------------------
-- Video config --
global constant vc_color=1,
	 vc_mode=2,
	 vc_lines=3,
	 vc_col=4,
	 vc_xpixels=5,
	 vc_ypixels=6,
	 vc_ncolors=7,
	 vc_pages=8
--------------------<Mouse>-------------------------------
global constant move = 1,
		left_down = 2,
		left_up = 4,
		right_down = 8,
		right_up = 16,
		middle_down = 32,
		middle_up = 64
------------------------------------------------------------------------------
global constant bmp_open_failed = 1,
		bmp_unexpected_eof = 2,
		bmp_unsupported_format = 3
global constant bmp_success = 0,
		bmp_invalid_mode = 4 -- invalid graphics mode
------------------------------------------------------------------------------
			    
--    GRAPHICS MODES --  argument to graphics_mode()

-- mode  description
-- ----  -----------
--   -1  restore to original default mode
--    0  40 x 25 text, 16 grey
--    1  40 x 25 text, 16/8 color
--    2  80 x 25 text, 16 grey
--    3  80 x 25 text, 16/8 color
--    7  80 x 25 text, BW
--    4  320 x 200, 4 color
--    5  320 x 200, 4 grey
--    6  640 x 200, BW
--   11  720 x 350, BW  (many video cards are lacking this one)
--   13  320 x 200, 16 color
--   14  640 x 200, 16 color
--   15  640 x 350, BW  (may be 4-color with blinking)
--   16  640 x 350, 4 or 16 color
--   17  640 x 480, BW
--   18  640 x 480, 16 color
--   19  320 x 200, 256 color
--  256  640 x 400, 256 color  (some cards are missing this one)
--  257  640 x 480, 256 color  (some cards are missing this one)
--  258  800 x 600, 16 color
--  259  800 x 600, 256 color
--  260  1024 x 768, 16 color
--  261  1024 x 768, 256 color
------------------------------------------------------------------------------
			    -- cursors --
global constant no_cursor= #2000,
		under_line= #0607,
		thick_underline= #0507,
		half_block= #0407,
		block= #0007
------------------------------------------------------------------------------
global constant screen=1,
		keyboard=0
------------------<Date>--------------------
global constant year=1,
		month=2,
		day=3,
		hour=4,
		minute=5,
		second=6,
		day_of_week=7,
		day_of_year=8
---------------- <File> ----------------------------
global constant d_name = 1,
		d_attr = 2,
		d_size = 3,
		d_year = 4,
		d_month = 5,
		d_day = 6,
		d_hour = 7,
		d_min = 8,
		d_sec = 9
	      
------------------------------------------------------------------------------
global constant dos32 = 1,
		win32 = 2,
		linux = 3
------------------------------------------------------------------------------
global constant white_space = " \t\n"
------------------------------------------------------------------------------
global constant true=1,
		false=0
global object max_rows,
	      max_cols,
	      vid
------------------------------------------------------------------------
global procedure cls()
clear_screen()
end procedure

------------------------------------------------------------------------------
global procedure color(object x)
text_color(x)
end procedure
------------------------------------------------------------------------------
global procedure pause()
object key
key = wait_key()
end procedure
------------------------------------------------------------------------------
global procedure bcolor(object x)
bk_color(x)
end procedure
------------------------------------------------------------------------------
global procedure error(sequence msg)
    text_color(b_red + 16)
    puts(1,msg)
    abort(1)
end procedure
------------------------------------------------------------------------------
global function get_input(object cur)
-- get user input from keyboard
    object line
    puts(1,cur)
    while true do
	line = gets(keyboard)
	if sequence(line) then
	    -- delete any leading whitespace
	    while find(line[1], white_space) do
		line = line[2..length(line)]
		if length(line) = 0 then
		    exit
		end if
	    end while
	    if length(line) > 0 then
		exit
	    end if
	end if
	puts(1, "\n> ")
    end while
    -- delete trailing whitespace
    while find(line[length(line)], white_space) do
	line = line[1..length(line)-1]
    end while
    return line
end function
------------------------------------------------------------------------------
--global function g_key(object msg)
--object i
--puts(1,msg)
--i=gets(0)
--return i
